<template>
    <v-layout row wrap class="card-container">
        <v-flex md12>
            <v-card>
                <v-container
                        fluid
                        grid-list-md
                >
                    <v-layout wrap>
                        <v-flex xs12 md12>
                            <v-layout nowrap>
                                <v-flex sm4 md3>
                                    <v-text-field prepend-icon="search" type="text" v-model="search"></v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-flex>
                        <v-flex xs12 md12>
                            <v-layout v-if="movies_search.length > 0" row wrap>
                                <movie-item v-for="(movie) in movies_search" v-bind:key="movie.title"
                                            v-bind:movie="movie" v-on:edit="edit"
                                            v-on:remove="remove"></movie-item>
                            </v-layout>
                            <v-layout v-else>
                                Il n'y a aucune film à montrer.
                            </v-layout>
                        </v-flex>
                    </v-layout>
                </v-container>
            </v-card>
        </v-flex>
    </v-layout>
</template>

<script>
    import {mapMutations, mapGetters, mapActions} from 'vuex'

    export default {
        name: 'movieManagement',
        data() {
            return {
                movie_to_add: {},
                search: ""
            }
        },
        mounted() {
            this.$store.dispatch('movieManagement/getMoviesFromAPI')
        },
        methods: {
            ...mapMutations({
                setMovies: 'movieManagement/setMovies'
            }),
            ...mapActions({
                deleteMovie: 'movieManagement/deleteMovieFromAPI'
            }),
            edit: function (id) {
                this.$router.push({path: '/edit/' + id})
            },
            remove: function (id) {
                this.deleteMovie(id)
            }
        },
        computed: {
            ...mapGetters({
                getMovies: 'movieManagement/getMovies',
                getMoviesSearch: 'movieManagement/getMoviesSearch'
            }),
            firstletter: function () {
                return this.message[0]
            },
            movies: {
                get() {
                    return this.getMovies
                },
                set(value) {
                    this.setMovies(value)
                }
            },
            movies_search: {
                get() {
                    return this.getMoviesSearch(this.search)
                },
                set(value) {
                    this.setMovies(value)
                }
            }
        }
    }
</script>

<style>
    .card-container {
        height: 100px;
    }
</style>

